//GDSIIExporter.h
//Copyright  2001-2005 Easy Math Solution. All Rights Reserved
//http://www.e-MathSolution.com
//For details contact us: info@e-MathSolution.com
#ifndef GDSIIEXPORTEREX_H
#define GDSIIEXPORTEREX_H

#include <TCHAR.H>
#include<windows.h>

#include <string>
#include "GDSIIConst.h"

//The type definitions
typedef void (__stdcall*TpfErrorHandler)(const TCHAR* err);

typedef void (__stdcall *TGDS_Path)(__int32 *pointsX, __int32 *pointsY, __int16 pointsNum, 
							__int32 width, __int16 layer, __int16 datatype, 
							__int16 pathtype, __int16 elflags, __int32 plex);

typedef void (__stdcall *TGDS_Boundary)(__int32 *pointsX, __int32 *pointsY, __int16 pNum, 
							__int16 layer,__int16 datatype,  __int16 elflags, 
							__int32 plex);
typedef void (__stdcall *TGDS_Circle)(__int32 centerX, __int32 centerY, __int32 radius,
							__int16 segmentNum, __int16 layer, __int16 datatype,
							__int16 elflags, __int32 plex);
typedef void (__stdcall *TGDS_Arc)(__int32 centerX, __int32 centerY, __int32 radius,
							double startAng, double endAng, __int16 segmentNum,
							__int32 width, __int16 layer, __int16 datatype, 
							__int16 pathtype, __int16 elflags, __int32 plex);
typedef void (__stdcall *TGDS_Sector)(__int32 centerX, __int32 centerY, __int32 radius,
							double startAng, double endAng, __int16 segmentNum,
							__int16 layer, __int16 datatype, __int16 elflags, 
							__int32 plex);

typedef void (__stdcall *TGDS_BoxWH)(__int32 x, __int32 y, __int32 width, __int32 height, 
							__int16 layer, __int16 boxtype, 
							__int16 elflags, __int32 plex);
typedef void (__stdcall *TGDS_Box)(__int32 x1, __int32 y1, __int32 x2, __int32 y2, 
							__int16 layer, __int16 boxtype, 
							__int16 elflags, __int32 plex);
typedef void (__stdcall *TGDS_Square)(__int32 x1, __int32 y1, __int32 side, 
							__int16 layer, __int16 boxtype, 
							__int16 elflags, __int32 plex);

typedef void (__stdcall *TGDS_Sref)(const TCHAR *strName, __int32 x, __int32 y, 
						__int16 strans, double mag, double angle, 
						__int16 elflags, __int32 plex);
typedef void (__stdcall *TGDS_Aref)( const TCHAR *strName, __int32 *x, __int32 *y, 
						__int16 col, __int16 row, __int16 strans, double mag, 
						double angle, __int16 elflags, __int32 plex);
	
typedef void (__stdcall *TGDS_BeginStructure)(TCHAR* strName);
typedef void (__stdcall *TGDS_EndStructure)(void);
	
typedef void (__stdcall *TGDS_BeginLib)(const TCHAR *fileName, double dbUserUnit, double dbUnitInMeter);
typedef void (__stdcall *TGDS_EndLib)(void);

typedef void (__stdcall *TGDS_Text)(__int32 pointsX, __int32 pointsY, const TCHAR *msg, 
							__int16 layer, __int16 txtType, __int16 presentation,
							__int16 pathtype, __int32 width, __int16 strans,	
							double mag, double angle, __int16 elflags, 
							__int32 plex);
typedef void (__stdcall *TGDS_Node)(__int32 *pointsX, __int32 *pointsY, __int16 pointsNum,
							__int16 layer, __int16 nodeType, __int16 elflags, 
							__int32 plex);
	
typedef void (__stdcall *TSetErrorHandle)(TpfErrorHandler);


//External variables
extern  TGDS_Path           GDS_Path;
extern	TGDS_Boundary		GDS_Boundary;
extern	TGDS_Circle			GDS_Circle;
extern	TGDS_Arc			GDS_Arc;
extern	TGDS_Sector			GDS_Sector;
extern	TGDS_BoxWH			GDS_BoxWH;
extern	TGDS_Box			GDS_Box;
extern	TGDS_Square			GDS_Square;
extern	TGDS_Sref			GDS_Sref;
extern	TGDS_Aref			GDS_Aref;
extern	TGDS_BeginStructure	GDS_BeginStructure;
extern	TGDS_EndStructure	GDS_EndStructure;
extern	TGDS_BeginLib		GDS_BeginLib;
extern	TGDS_EndLib			GDS_EndLib;
extern	TGDS_Text			GDS_Text;
extern	TGDS_Node			GDS_Node;
extern	TSetErrorHandle	     SetErrorHandle;

//////////////////////////////////////////////////////////////////////////
//Load & UnLoad GDSIIExporter.dll
bool LoadGDSIIExporter(void);
void UnLoadGDSIIExporter(void);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Exception class
class GDSIIException
{
public:
	GDSIIException(const TCHAR *msg){ error.assign(msg); }
	const TCHAR * getError( void ) const { return error.c_str(); }
private:
	std::basic_string<TCHAR> error;
};
#endif